﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Drawing;
using System.Text;

namespace RobowiiL
{
    enum rectType{rectX, rectY, rectZ};

    class GraphRect
    {
        Rectangle gf;

        public GraphRect(Rectangle gf)
        {
            this.gf = gf;
        }

        public Rectangle GetRect()
        {
            return gf;
        }

        public void Paint(Graphics paintevent )
        {
            Pen BluePen =  new Pen(Color.Blue);
            paintevent.DrawLine(BluePen, gf.Left, gf.Top + gf.Height / 2, gf.Right, gf.Top + gf.Height / 2);
        }

        public void PaintXYZ(Graphics paintevent)
        {
            Pen BluePen = new Pen(Color.Blue);
            paintevent.DrawLine(BluePen, gf.Left, gf.Top + gf.Height / 2, gf.Right, gf.Top + gf.Height / 2);
            paintevent.DrawLine(BluePen, gf.Left + gf.Width / 2, gf.Top, gf.Left + gf.Width / 2, gf.Bottom);
            paintevent.DrawLine(BluePen, gf.Left, gf.Bottom, gf.Right, gf.Top);

        }


        public void PaintGesture(Graphics paintevent, double[] coordI, double[] coordF)
        {
            float width = 2;
            Pen PurplePen = new Pen(Color.Purple, width);
            Pen GreenPen = new Pen(Color.Green, width);


            for (int i = 1; i < 250; i++)
            {

                paintevent.DrawLine(PurplePen, gf.Left + (i - 1) * gf.Width / 250, (float)(gf.Top + gf.Height / 2 + coordI[i - 1] * gf.Height / 10), gf.Left + i * gf.Width / 250, (float)(gf.Top + gf.Height / 2 + coordI[i] * gf.Height / 10));
                paintevent.DrawLine(GreenPen, gf.Left + (i - 1) * gf.Width / 250, (float)(gf.Top + gf.Height / 2 + coordF[i - 1] * gf.Height / 10), gf.Left + i * gf.Width / 250, (float)(gf.Top + gf.Height / 2 + coordF[i] * gf.Height / 10));

            }

        }

        public void PaintGestureXYZ(Graphics paintevent, double[] coordX, double[] coordY, double[] coordZ)
        {
            Pen PurplePen = new Pen(Color.Purple);
            Pen GreenPen = new Pen(Color.Green);

            double xv0,xv1;
            double yv0,yv1;

            xv0 = gf.Left + gf.Width / 2 + (coordY[0] - coordX[0] * 0.707)*10;
            yv0 = gf.Top + gf.Height / 2 - (coordZ[0] - coordX[0] * 0.707)*10;


            for (int i = 1; i < 250; i++)
            {

               // paintevent.DrawLine(PurplePen, (float)(gf.Left + gf.Width / 2 + coordX[i - 1] * 20), (float)(gf.Top + gf.Height / 2 + coordY[i - 1] * 20), (float)(gf.Left + gf.Width / 2 + coordX[i] * 20), (float)(gf.Top + gf.Height / 2 + coordY[i] * 20));
              //  paintevent.DrawLine(GreenPen, gf.Left + (i - 1) * gf.Width / 250, (float)(gf.Top + gf.Height / 2 + coordF[i - 1] * gf.Height / 10), gf.Left + i * gf.Width / 250, (float)(gf.Top + gf.Height / 2 + coordF[i] * gf.Height / 10));


                xv1 = gf.Left + gf.Width / 2 + (coordY[i] - coordX[i] * 0.707)*10;
                yv1 = gf.Top + gf.Height / 2 - (coordZ[i] - coordX[i] * 0.707)*10;
                paintevent.DrawLine(PurplePen, (float)xv0, (float)yv0, (float)xv1, (float)yv1);
                xv0 = xv1;
                yv0 = yv1;
            }
        }
    }
}
