﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;



namespace RobowiiL
{
   
   /* struct MyPoint3D
    {
       public double x;
       public double y;
       public double z;

    };*/
    [Serializable()]
    //implementa l'interfaccia ISerializable
    public class Model : ISerializable
    {
        const int MAX = 250;


        string classifierName;
        //Array spostamenti fisici
        double[] XaccSens;
        double[] YaccSens;
        double[] ZaccSens;
        //Array spostamenti Interpolati
        double[] XaccInter;
        double[] YaccInter;
        double[] ZaccInter;
        //Array di rotazioni fisiche
        bool[] rollSens;
        bool[] pitchSens;
        bool[] yawSens;
        //Array di rotazioni Interpolate
        bool[] rollInter;
        bool[] pitchInter;
        bool[] yawInter;
        //Array speed data from motion plus fisiche
        double[] speedXSens;
        double[] speedYSens;
        double[] speedZSens;
        //Array speed data from motion plus Interpolate
        double[] speedXInter;
        double[] speedYInter;
        double[] speedZInter;


        double interpolationRatio;
        //MyPoint3D[] points;

        int count;


        private void initializeComponent()
        {
            XaccSens = new double[MAX];
            YaccSens = new double[MAX];
            ZaccSens = new double[MAX];

            XaccInter = new double[MAX];
            YaccInter = new double[MAX];
            ZaccInter = new double[MAX];

            rollSens = new bool[MAX];
            pitchSens = new bool[MAX];
            yawSens = new bool[MAX];

            rollInter = new bool[MAX];
            pitchInter = new bool[MAX];
            yawInter = new bool[MAX];

            speedXSens = new double[MAX];
            speedYSens = new double[MAX];
            speedZSens = new double[MAX];

            speedXInter = new double[MAX];
            speedYInter = new double[MAX];
            speedZInter = new double[MAX];


            //points = new MyPoint3D[MAX];
            interpolationRatio = 1;
            count = 0;
        
        }


        public Model()
        {
            this.initializeComponent();
        }//private void Model

        public Model(string PclassifierName)
        {
           
            this.classifierName = PclassifierName;
            this.initializeComponent();
           
        }//private void Model


        public Model(SerializationInfo info, StreamingContext ctxt)
        {
            this.classifierName = (string)info.GetValue("ClassifierName", typeof(string));

            this.XaccSens = (double[])info.GetValue("XaccSens", typeof(double[]));
            this.YaccSens = (double[])info.GetValue("YaccSens", typeof(double[]));
            this.ZaccSens = (double[])info.GetValue("ZaccSens", typeof(double[]));

            this.XaccInter = (double[])info.GetValue("XaccInter", typeof(double[]));
            this.YaccInter = (double[])info.GetValue("YaccInter", typeof(double[]));
            this.ZaccInter = (double[])info.GetValue("ZaccInter", typeof(double[]));

            this.rollSens = (bool[])info.GetValue("rollSens", typeof(bool[]));
            this.pitchSens = (bool[])info.GetValue("pitchSens", typeof(bool[]));
            this.yawSens = (bool[])info.GetValue("yawSens", typeof(bool[]));

            this.rollInter = (bool[])info.GetValue("rollInter", typeof(bool[]));
            this.pitchInter = (bool[])info.GetValue("pitchInter", typeof(bool[]));
            this.yawInter = (bool[])info.GetValue("yawInter", typeof(bool[]));

            this.speedXSens = (double[])info.GetValue("speedXSens", typeof(double[]));
            this.speedYSens = (double[])info.GetValue("speedYSens", typeof(double[]));
            this.speedZSens = (double[])info.GetValue("speedZSens", typeof(double[]));

            this.speedXInter = (double[])info.GetValue("speedXInter", typeof(double[]));
            this.speedYInter = (double[])info.GetValue("speedYInter", typeof(double[]));
            this.speedZInter = (double[])info.GetValue("speedZInter", typeof(double[]));

            this.interpolationRatio = (double)info.GetValue("interpolationRatio", typeof(double));
            this.count = (int)info.GetValue("count", typeof(int));
        }//private void Model

        public void GetObjectData(SerializationInfo info, StreamingContext ctxt)
        {
            info.AddValue("ClassifierName", this.classifierName);

            info.AddValue("XaccSens", this.XaccSens);
            info.AddValue("YaccSens", this.YaccSens);
            info.AddValue("ZaccSens", this.ZaccSens);

            info.AddValue("XaccInter", this.XaccInter);
            info.AddValue("YaccInter", this.YaccInter);
            info.AddValue("ZaccInter", this.ZaccInter);

            info.AddValue("rollSens", this.rollSens);
            info.AddValue("pitchSens", this.pitchSens);
            info.AddValue("yawSens", this.yawSens);

            info.AddValue("rollInter", this.rollInter);
            info.AddValue("pitchInter", this.pitchInter);
            info.AddValue("yawInter", this.yawInter);

            info.AddValue("speedXSens", this.speedXSens);
            info.AddValue("speedYSens", this.speedYSens);
            info.AddValue("speedZSens", this.speedZSens);

            info.AddValue("speedXInter", this.speedXInter);
            info.AddValue("speedYInter", this.speedYInter);
            info.AddValue("speedZInter", this.speedZInter);

            info.AddValue("interpolationRatio", this.interpolationRatio);
            info.AddValue("count", this.count);

        }




        public void AddValue( double x, double y, double z)
        {
            if (count > MAX-1)
                return;
            XaccSens[count] = x;
            YaccSens[count] = y;
            ZaccSens[count] = z;

        //    points[i].x = x;
        //    points[i].y = y;
        //    points[i].z = z;

            
            count++;
        }//AddValue

        public void AddValue(double x, double y, double z, bool roll, bool pitch, bool yaw)
        {
            if (count > MAX - 1)
                return;
            XaccSens[count] = x;
            YaccSens[count] = y;
            ZaccSens[count] = z;

            rollSens[count] = roll;
            pitchSens[count] = pitch;
            yawSens[count] = yaw;

            count++;
        }//AddValue

        public void AddValue(double x, double y, double z, bool roll, bool pitch, bool yaw, double speedX, double speedY, double speedZ)
        {
            if (count > MAX - 1)
                return;
            XaccSens[count] = x;
            YaccSens[count] = y;
            ZaccSens[count] = z;

            rollSens[count] = roll;
            pitchSens[count] = pitch;
            yawSens[count] = yaw;

            speedXSens[count] = speedX;
            speedYSens[count] = speedY;
            speedZSens[count] = speedZ;


            count++;
        }//AddValue
      
        
        public string GetName()
        {
            return this.classifierName; 
        }

        
//**************** GetX method *************
        public double GetX(int i)
        {
            return this.XaccInter[i];
        }
        public double[] GetX()
        {
            return this.XaccInter;
        }
        public double[] GetXF()
        {
            return this.XaccSens;
        }
//**************** GetY method *************
        public double GetY(int i)
        {
            return this.YaccInter[i];
        }
        public double[] GetY()
        {
            return this.YaccInter;
        }
        public double[] GetYF()
        {
            return this.YaccSens;
        }
//**************** GetZ method *************
        public double GetZ(int i)
        {
            return this.ZaccInter[i];
        }
        public double[] GetZ()
        {
            return this.ZaccInter;
        }
        public double[] GetZF()
        {
            return this.ZaccSens;
        }

//**************** Get Gyroscope Value *******************

//**************** Roll *********************
        public bool GetRoll(int i)
        {
            return this.rollInter[i];
        }

        public bool[] GetRoll()
        {
            return this.rollInter;
        }

        public bool[] GetRollF()
        {
            return this.rollSens;
        }
//**************** Pitch *********************
        public bool GetPitch(int i)
        {
            return this.pitchInter[i];
        }

        public bool[] GetPitch()
        {
            return this.pitchInter;
        }

        public bool[] GetPitchF()
        {
            return this.pitchSens;
        }
//**************** Yaw *********************
        public bool GetYaw(int i)
        {
            return this.yawInter[i];
        }

        public bool[] GetYaw()
        {
            return this.yawInter;
        }

        public bool[] GetYawF()
        {
            return this.yawSens;
        }
//**************** SpeedX *********************
        public double GetXSpeed(int i)
        {
            return this.speedXInter[i];
        }

        public double[] GetXSpeed()
        {
            return this.speedXInter;
        }

        public double[] GetXSpeedF()
        {
            return this.speedXSens;
        }
 //**************** SpeedY *********************
        public double GetYSpeed(int i)
        {
            return this.speedYInter[i];
        }

        public double[] GetYSpeed()
        {
            return this.speedYInter;
        }

        public double[] GetYSpeedF()
        {
            return this.speedYSens;
        }
//**************** SpeedZ *********************
        public double GetZSpeed(int i)
        {
            return this.speedZInter[i];
        }

        public double[] GetZSpeed()
        {
            return this.speedZInter;
        }

        public double[] GetZSpeedF()
        {
            return this.speedZSens;
        }



//**************** GetPoint ****************
     /*   public MyPoint3D GetPoint(int i)
        {
            return this.points[i];
        }
        */
//**************** Debugging functions which initialize the sensor array *****
        private void FakeValues()
        {
            //Only for testing
            int indexI;
            this.count = 100;
            for (indexI = 0; indexI < 100; indexI++)
            {
                double t = indexI;

                t = t /5;

                this.XaccSens[indexI] = 5*Math.Sin(t);
                this.YaccSens[indexI] = t;
                this.ZaccSens[indexI] = 5*Math.Cos(t);
            }

        }

        /*
         * L'interpolationRatio è data dal rapporto di count/Max.
         * Quindi il nostro Dt nella derivata sarà dato da 1/interpolationRatio.
          */

        public void Interpolate()
        {//http://en.wikipedia.org/wiki/Cubic_Hermite_spline
            //this.FakeValues();
            interpolationRatio = count;
            interpolationRatio = interpolationRatio / MAX;
            //interpolationRatio = interpolationRatio/2; //boh?!?!

            int indexI, indexF;
            double t, m0_X = 0, m1_X = 0, m0_Y = 0, m1_Y = 0, m0_Z=0, m1_Z=0;
            double m0s_X = 0, m1s_X = 0, m0s_Y = 0, m1s_Y = 0, m0s_Z = 0, m1s_Z = 0;


            for (indexI = 0; indexI < MAX; indexI++)
            {
                indexF = (int)(indexI * interpolationRatio);//indice reale

                t = (indexI * interpolationRatio) - indexF;
                
                if (t == 0)//entro solo se sono in un campione reale
                {
                    if (indexF == 0)//punto iniziale
                    {
                        m0_X = this.XaccSens[indexF] * interpolationRatio;
                        m0_Y = this.YaccSens[indexF] * interpolationRatio;
                        m0_Z = this.ZaccSens[indexF] * interpolationRatio; 

                        m0s_X = this.speedXSens[indexF] * interpolationRatio;
                        m0s_Y = this.speedYSens[indexF] * interpolationRatio;
                        m0s_Z = this.speedZSens[indexF] * interpolationRatio;
                    }
                    else//tangente punto iniziale nei punti intermedi 
                    {
                        m0_X = (this.XaccSens[indexF] - this.XaccInter[indexI - 1]) * interpolationRatio;
                        m0_Y = (this.YaccSens[indexF] - this.YaccInter[indexI - 1]) * interpolationRatio;
                        m0_Z = (this.ZaccSens[indexF] - this.ZaccInter[indexI - 1]) * interpolationRatio;

                        m0s_X = (this.speedXSens[indexF] - this.speedXInter[indexI - 1]) * interpolationRatio;
                        m0s_Y = (this.speedYSens[indexF] - this.speedYInter[indexI - 1]) * interpolationRatio;
                        m0s_Z = (this.speedZSens[indexF] - this.speedZInter[indexI - 1]) * interpolationRatio;
                    }
                    if (indexF == this.count - 1)//punto finale
                    {
                        m1_X = 0;
                        m1_Y = 0;
                        m1_Z = 0;

                        m1s_X = 0;
                        m1s_Y = 0;
                        m1s_Z = 0;
                    }
                    else//tangente punto finale nei punti intermedi
                        if (indexF == 0)
                        {
                            m1_X = (this.XaccSens[indexF + 1] - this.XaccInter[indexF]) * interpolationRatio;
                            m1_Y = (this.YaccSens[indexF + 1] - this.YaccInter[indexF]) * interpolationRatio;
                            m1_Z = (this.ZaccSens[indexF + 1] - this.ZaccInter[indexF]) * interpolationRatio;

                            m1s_X = (this.speedXSens[indexF + 1] - this.speedXInter[indexF]) * interpolationRatio;
                            m1s_Y = (this.speedYSens[indexF + 1] - this.speedYInter[indexF]) * interpolationRatio;
                            m1s_Z = (this.speedZSens[indexF + 1] - this.speedZInter[indexF]) * interpolationRatio;
                        }
                        else
                        {
                            m1_X = (this.XaccSens[indexF + 1] - this.XaccInter[indexI - 1]) * interpolationRatio;
                            m1_Y = (this.YaccSens[indexF + 1] - this.YaccInter[indexI - 1]) * interpolationRatio;
                            m1_Z = (this.ZaccSens[indexF + 1] - this.ZaccInter[indexI - 1]) * interpolationRatio;

                            m1s_X = (this.speedXSens[indexF + 1] - this.speedXInter[indexI - 1]) * interpolationRatio;
                            m1s_Y = (this.speedYSens[indexF + 1] - this.speedYInter[indexI - 1]) * interpolationRatio;
                            m1s_Z = (this.speedZSens[indexF + 1] - this.speedZInter[indexI - 1]) * interpolationRatio;
                        }
                }
                
                //Cubic Hermit Spline
                //this.XaccInter[indexI] = (2*t*t*t - 3*t*t + 1) * this.XaccSens[indexF] + (t*t*t - 2*t*t + t)*m0 +(-2*t*t*t + 3*t*t)*this.XaccSens[indexF+1] + (t*t*t - t*t)*m1;
                if (indexI == MAX - 1)
                {
                    this.XaccInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.XaccSens[indexF] + (t * t * t - 2 * t * t + t) * m0_X + (-2 * t * t * t + 3 * t * t) * this.XaccSens[indexF] + (t * t * t - t * t) * m1_X;
                    this.YaccInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.YaccSens[indexF] + (t * t * t - 2 * t * t + t) * m0_Y + (-2 * t * t * t + 3 * t * t) * this.YaccSens[indexF] + (t * t * t - t * t) * m1_Y;
                    this.ZaccInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.ZaccSens[indexF] + (t * t * t - 2 * t * t + t) * m0_Z + (-2 * t * t * t + 3 * t * t) * this.ZaccSens[indexF] + (t * t * t - t * t) * m1_Z;

                    this.speedXInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.speedXSens[indexF] + (t * t * t - 2 * t * t + t) * m0_X + (-2 * t * t * t + 3 * t * t) * this.speedXSens[indexF] + (t * t * t - t * t) * m1_X;
                    this.speedYInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.speedYSens[indexF] + (t * t * t - 2 * t * t + t) * m0_Y + (-2 * t * t * t + 3 * t * t) * this.speedYSens[indexF] + (t * t * t - t * t) * m1_Y;
                    this.speedZInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.speedZSens[indexF] + (t * t * t - 2 * t * t + t) * m0_Z + (-2 * t * t * t + 3 * t * t) * this.speedZSens[indexF] + (t * t * t - t * t) * m1_Z;


                }
                else
                {
                    this.XaccInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.XaccSens[indexF] + (t * t * t - 2 * t * t + t) * m0_X + (-2 * t * t * t + 3 * t * t) * this.XaccSens[indexF + 1] + (t * t * t - t * t) * m1_X;
                    this.YaccInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.YaccSens[indexF] + (t * t * t - 2 * t * t + t) * m0_Y + (-2 * t * t * t + 3 * t * t) * this.YaccSens[indexF + 1] + (t * t * t - t * t) * m1_Y;
                    this.ZaccInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.ZaccSens[indexF] + (t * t * t - 2 * t * t + t) * m0_Z + (-2 * t * t * t + 3 * t * t) * this.ZaccSens[indexF + 1] + (t * t * t - t * t) * m1_Z;

                    this.speedXInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.speedXSens[indexF] + (t * t * t - 2 * t * t + t) * m0_X + (-2 * t * t * t + 3 * t * t) * this.speedXSens[indexF + 1] + (t * t * t - t * t) * m1_X;
                    this.speedYInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.speedYSens[indexF] + (t * t * t - 2 * t * t + t) * m0_Y + (-2 * t * t * t + 3 * t * t) * this.speedYSens[indexF + 1] + (t * t * t - t * t) * m1_Y;
                    this.speedZInter[indexI] = (2 * t * t * t - 3 * t * t + 1) * this.speedZSens[indexF] + (t * t * t - 2 * t * t + t) * m0_Z + (-2 * t * t * t + 3 * t * t) * this.speedZSens[indexF + 1] + (t * t * t - t * t) * m1_Z;

                
                
                }

                this.rollInter[indexI] = this.rollSens[indexF];
                this.pitchInter[indexI] = this.pitchSens[indexF];
                this.yawInter[indexI] = this.yawSens[indexF];


            }
        
        }

    }
}
