﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO.Ports;
using System.Threading;
using System.Windows.Forms;
using WiimoteLib;//from wiilib

namespace RobowiiL
{
    public class nxtCommand
    {
        private SerialPort bconnPredatore;//Predator serial port number to connect
        private SerialPort bconnPreda;//Preda serial port number to connect
        private RoboMain roboM;//robot main class developed By 2(G.P.)
        private List<command> CmdList = new List<command>();


        public nxtCommand(SerialPort bconnPredatore, SerialPort bconnPreda, RoboMain roboM)
        {
            this.bconnPredatore = bconnPredatore;
            this.bconnPreda = bconnPreda;
            this.roboM = roboM;
        }

        //public void ParseCmd(string cmd)//da cambiare perche gli dobbiamo mandare l'intero comando
        public void ParseCmd(command cmd)//da cambiare perche gli dobbiamo mandare l'intero comando
        {
            switch (cmd.GetName())
            {
                case "Avanti":
                    this.forward();
                    break;

                case "Indietro":
                    this.backward();
                    break;

                case "Sinistra":
                    this.turnLeft();
                    break;

                case "Destra":
                    this.turnRight();
                    break;

                case "Shake":
                    this.attack();
                    break;

                case "Cerchio":
                    this.turn180();
                    break;

                case "Quadrato":
                    this.turnRight();
                    break;

                case "BreakAll":
                    this.breakbtnCmd();
                    break;

            }
        }

        public void AddCmd(command Pcmd)
        {
            this.CmdList.Add(Pcmd);
            //per prova eivtiamo il thread
            ParseCmd(Pcmd);
        }

        private bool TestWin()
        {
            //byte[] Command = { 0x00, 0x13, 0x0a, 0x00, 0x01 };
            int resPredatore = this.NXTSendCommandTestWin(bconnPredatore);
            int resPreda = this.NXTSendCommandTestWin(bconnPreda);

            if (resPredatore == 1 && resPreda == 1)
            {
                int remainingHit = roboM.Hit();

                if (roboM.Alive())
                {
                    roboM.externwriteOnLog("Devi colpirlo ancora " + remainingHit +" volta per vincere!\n");//log on gui
                    return false;
                }
                roboM.TimerStop();
                roboM.ExternWinMessage();
                return true;

            }
            return false;
        }//TestWin()

        //NXTSendCommandAndGetReply
        //this function permit to send message and read reply trought bluetooth
        private int NXTSendCommandTestWin(SerialPort bConn)
        {
            Byte[] MessageLength = { 0x00, 0x00 };
            string msg = "";
            string typeResponse = "";
            string value = "";
            byte[] Command = { 0x00, 0x13, 0x0a, 0x00, 0x01 };

            MessageLength[0] = (byte)Command.Length;
            msg += "TX:";
            for (int i = 0; i < Command.Length; i++)
                msg += Command[i].ToString("X2") + " ";
            msg += "\n";
            roboM.externwriteOnLog(msg);//log on gui
            bConn.Write(MessageLength, 0, MessageLength.Length);//write on virtual com port
            bConn.Write(Command, 0, Command.Length);

            int length = 0;

            msg = "";
            try
            {
                length = bConn.ReadByte() + 256 * bConn.ReadByte();
            }
            catch(TimeoutException ex)
            {
                roboM.externwriteOnLog("Impossibile comunicare con l'NXT");
                return 0;
            }

            msg += "RX:";
            int rVal = -1;
            for (int i = 0; i < length; i++)
            {
                if (i == 5)
                {

                    rVal = bConn.ReadByte();

                    msg += rVal.ToString("X2") + " ";
                }
                else
                {
                    try
                    {
                        msg += bConn.ReadByte().ToString("X2") + " ";
                    }
                    catch (TimeoutException e)
                    {

                    }
                }
            }

            msg += "\n";

            roboM.externwriteOnLog(msg);//log on gui
            return rVal;
        }
        //NXTSendCommandAndGetReply
        //this function permit to send message and read reply trought bluetooth
        private void NXTSendCommandAndGetReply(byte[] Command)
        {
            Byte[] MessageLength = { 0x00, 0x00 };
            string msg = "";
            string typeResponse = "";
            string value = "";


            MessageLength[0] = (byte)Command.Length;
            msg += "TX:";
            for (int i = 0; i < Command.Length; i++)
                msg += Command[i].ToString("X2") + " ";
            msg += "\n";
            roboM.externwriteOnLog(msg);//log on gui

            bconnPredatore.Write(MessageLength, 0, MessageLength.Length);//write on virtual com port
            bconnPredatore.Write(Command, 0, Command.Length);
            int length;

            if (Command[0] == 0x00)//if we wait for reply from NXT
            {
                msg = "";

                length = bconnPredatore.ReadByte() + 256 * bconnPredatore.ReadByte();
                msg += "RX:";
                int rVal = -1;
                for (int i = 0; i < length; i++)
                {
                    msg += bconnPredatore.ReadByte().ToString("X2") + " ";
                }
                msg += "\n";

                roboM.externwriteOnLog(msg);//log on gui

            }

        }

        private void NXTSendCommandAndGetReply(SerialPort bconn, byte[] Command)
        {
            Byte[] MessageLength = { 0x00, 0x00 };
            string msg = "";
          
            MessageLength[0] = (byte)Command.Length;
            msg += "TX:";
            for (int i = 0; i < Command.Length; i++)
                msg += Command[i].ToString("X2") + " ";
            msg += "\n";
            roboM.externwriteOnLog(msg);//log on gui

            bconn.Write(MessageLength, 0, MessageLength.Length);//write on virtual com port
            bconn.Write(Command, 0, Command.Length);
            int length;

            if (Command[0] == 0x00)//if we wait for reply from NXT
            {
                msg = "";

                length = bconn.ReadByte() + 256 * bconnPredatore.ReadByte();
                msg += "RX:";
                int rVal = -1;
                for (int i = 0; i < length; i++)
                {
                    msg += bconn.ReadByte().ToString("X2") + " ";
                }
                msg += "\n";

                roboM.externwriteOnLog(msg);//log on gui

            }

        }

        //******* here start cmd sent to nxt via BT ********



        public void SoundCmd(object sender, EventArgs e)
        {
            byte[] NxtMessage = { 0x00, 0x03, 0x07, 0xda, 0xf0, 0x00 };

            NXTSendCommandAndGetReply(NxtMessage);
        }

        public void MotorACmd()
        {
            byte[] NxtMessage = { 0x00,
								  0x04, //input command
								  0x00, //n port, ff all motors
								  0x64, //power
								  0x01, //mode
								  0x00, //regulation
								  0x10, //turn ratio
								  0x20, //runstate
								  0x00, 0x00, 0x00, 0x00 };//angle

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void breakbtnCmd()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
								  0x09, //command messagewrite o messageread?!
								  0x01, //inbox number  (numero arbitrario da 9 a 0)
								  0x03, //message size
								  48,
								  57,   //9
								  00,
								  00,
								  00,
								  00
								 };//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void turnAround()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
								  0x09, //command messagewrite o messageread?!
								  0x01, //inbox number  (numero arbitrario da 9 a 0)
								  0x03, //message size
								  48,
								  53,   //5
								  00,
								  00,
								  00,
								  00  };//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void turnLeft()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
								  0x09, //command messagewrite o messageread?!
								  0x01, //inbox number  (numero arbitrario da 9 a 0)
								  0x03, //message size
								  48,
								  52,   //4
								  00,
								  00,
								  00,
								  00
								};//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void attack()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
								  0x09, //command messagewrite o messageread?!
								  0x01, //inbox number  (numero arbitrario da 9 a 0)
								  0x03, //message size
								  48,
								  55,   //7
								  00,
								  00,
								  00,
								  00
								};//messagedata

            NXTSendCommandAndGetReply(NxtMessage);
            Thread.Sleep(1000);
            bool res = TestWin();

        }

        public void resetRotate()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
								  0x09, //command messagewrite o messageread?!
								  0x01, //inbox number  (numero arbitrario da 9 a 0)
								  0x03, //message size
								  48,
								  54,   //6
								  00,
								  00,
								  00,
								  00
								};//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void turn180()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
								  0x09, //command messagewrite o messageread?!
								  0x01, //inbox number  (numero arbitrario da 9 a 0)
								  0x03, //message size
								  48,
								  56,   //8
								  00,
								  00,
								  00,
								  00
								};//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }
        //public void turnRight()
        public void turnRight()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
								  0x09, //command messagewrite o messageread?!
								  0x01, //inbox number  (numero arbitrario da 9 a 0)
								  0x03, //message size
								  48,
								  51,   //3
								  00,
								  00,
								  00,
								  00  };//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }


        //public void forward()
        public void forward()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
								  0x09, //command messagewrite o messageread?!
								  0x01, //inbox number  (numero arbitrario da 9 a 0)
								  0x03, //message size (stringa + fine stringa)
								  48,   //1
								  49,
								  00,
								  00,
								  00,
								  00
								  };//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }

        //public void backward()
        public void backward()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
								  0x09, //command messagewrite o messageread?!
								  0x01, //inbox number  (numero arbitrario da 9 a 0)
								  0x03, //message size
								  48,
								  50,   //2
								  00,
								  00,
								  00,
								  00  };//messagedata


            NXTSendCommandAndGetReply(NxtMessage);

        }
        //************************************************************************************


        public void sendLevel(int level)
        {
            byte levelB =(byte) (level + 48);
            byte[] NxtMessage = { 0x80, //senza risposta
							  0x09, //command messagewrite o messageread?!
							  0x01, //inbox number  (numero arbitrario da 9 a 0)
							  0x03, //message size
							  48,
							  levelB, //level range 1-6
							  00,
							  00,
							  00,
							  00
							};//messagedata

            NXTSendCommandAndGetReply(bconnPreda, NxtMessage);

        }
    }
}
