﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;
using System.Windows.Forms;
using System.Threading;
using WiimoteLib;//from wiilib


namespace RobowiiL
{
    public class WiiControl
    {
        const double kFilteringFactor = 0.4;
        String str;
        bool recording = false;
        private RoboMain roboM;
        private nxtCommand nxc;
        bool startRecording = false, breakAll = false, attack = false;
        double accelX, accelY, accelZ;
        private int contR=0;

        private double angleX = 0;
        private double angleY = 0;
        private double angleZ = 0;

        //variabili di claibratura
        private bool calibrate = true;
        private int calibrateCount = 0;
        private double calibrationValueX = 0;
        private double[] calibrationValuesX = new double[20];
        private double calibrationValueY = 0;
        private double[] calibrationValuesY = new double[20];
        private double calibrationValueZ = 0;
        private double[] calibrationValuesZ = new double[20];



        //private int pointIndex = 0;
       // public static Screen screen;

        public WiiControl(RoboMain roboM)
        {
            this.roboM = roboM;
            accelX = 0;
            accelY = 0;
            accelZ = 0;
        }
        public WiiControl(RoboMain roboM,nxtCommand nxc)
        {
            this.roboM = roboM;
            accelX = 0;
            accelY = 0;
            accelZ = 0;
            this.nxc = nxc;
        }


        private void CalibrateWiiMotePlus(WiimoteState ws)
        {
            //basta che controlliamo uno dei tre
            int index = 0;
            if (calibrateCount != 0)
                index = calibrateCount - 1;
            if (calibrateCount <= 20)
            {
                //per ora nessun controllo se fast o slow.. andrebbe messo, anche se sarebbe
                //un errore muovere il wiimote, servirebbe come rilevamento di errore
                this.calibrationValuesX[index] = ws.MotionPlusState.RawValues.X;
                this.calibrationValuesY[index] = ws.MotionPlusState.RawValues.Y;
                this.calibrationValuesZ[index] = ws.MotionPlusState.RawValues.Z;
                calibrateCount++;
            }
            else
            {
                this.calibrate = false;
                this.calibrationValueX = this.calibrationValuesX.Average();
                this.calibrationValueY = this.calibrationValuesY.Average();
                this.calibrationValueZ = this.calibrationValuesZ.Average();
            }
        }




        //public bool A, B, Plus, Home, Minus, One, Two, Up, Down, Left, Right;
        public void wm_WiimoteChanged(object sender, WiimoteChangedEventArgs args)
        {
            WiimoteState ws = args.WiimoteState;
            //NON CANCELLARE BREAK DI EMERGENZA


            if (ws.ButtonState.B)
            {
                breakAll = true;
                str = "button B: Start\n";
                roboM.externwriteOnLog(str);
            }
            else
            {
                if (nxc != null && breakAll == true)
                {
                    breakAll = false;
                    command currCmd = new command("BreakAll", 0.5);
                    this.nxc.ParseCmd(currCmd);
                    
                    str = "BreakAll\n";
                    roboM.externwriteOnLog(str);
                    //this.nxc.breakbtnCmd();
                }
            }
            if (ws.ButtonState.Down)
            {
                if (attack == false)
                {
                    attack = true;
                    command currCmd = new command("Shake", 0.5);
                    this.nxc.ParseCmd(currCmd);
                    str = "button down: Pressed\n";
                    roboM.externwriteOnLog(str);
                    str = "Attack\n";
                    roboM.externwriteOnLog(str);
                    //this.nxc.breakbtnCmd();
                }
            }
            else if (attack == true && !ws.ButtonState.Down)
            {
                attack = false;
            }
            /*
            if (ws.ButtonState.Down && attack)
            {
                attack = true;
                str = "button down: Pressed\n";
                roboM.externwriteOnLog(str);
            }
            else
            {
                if (nxc != null && !attack)
                {
                    attack = false;
                    command currCmd = new command("Shake", 0.5);
                    this.nxc.ParseCmd(currCmd);

                    str = "Attack\n";
                    roboM.externwriteOnLog(str);
                    //this.nxc.breakbtnCmd();
                }
            }*/
            //ws.MotionPlusState.Values.X;
            if (this.calibrate)
                CalibrateWiiMotePlus(ws);


            if (!recording)
            {
                if (ws.ButtonState.A)
                {
                    str = "button A: start recording\n";
                    if (roboM.training)
                        roboM.ExternCreateNewModel();
                    else
                        roboM.CreateNewRecognitionModel();
                  //  pointIndex = 0;
                    recording = true;
                    roboM.externwriteOnLog(str);
                }
            }
            else
            {
                if (!ws.ButtonState.A)
                {
                    str = "button A: end recording\n";
                   // pointIndex = 0;
                    recording = false;
                    startRecording = false;
                    roboM.externwriteOnLog(str);     
                    //roboM.PrintModel();
                    
                    if (roboM.training)
                    {
                        roboM.PrintLastModel();
                        roboM.InterpolateLastModel();
                        //roboM.IncrementModelIndex();
                    }
                    else
                    {
                        roboM.InterpolateRecognitionModel();
                        roboM.LastModelRecognition();
                    }
                    accelX = 0;
                    accelY = 0;
                    accelZ = 0;
                    angleX = 0;
                    angleY = 0;
                    angleZ = 0;
                    contR = 0;
                }
                
            }
            if (!recording)//next value don't care.
                return;



          //  accelX = ws.AccelState.Values.X - ((ws.AccelState.Values.X * kFilteringFactor) + (accelX * (1.0 - kFilteringFactor)));
          //  accelY = ws.AccelState.Values.Y - ((ws.AccelState.Values.Y * kFilteringFactor) + (accelY * (1.0 - kFilteringFactor)));
          //  accelZ = ws.AccelState.Values.Z - ((ws.AccelState.Values.Z * kFilteringFactor) + (accelZ * (1.0 - kFilteringFactor)));
            if (contR == 0)
            {
                accelX = ws.AccelState.Values.X;
                accelY = ws.AccelState.Values.Y;
                accelZ = ws.AccelState.Values.Z;
                angleX = ws.MotionPlusState.RawValues.Z;
                angleY = ws.MotionPlusState.RawValues.X;
                angleZ = ws.MotionPlusState.RawValues.Y;
                contR++;
            }
            else
            {
                if (Math.Abs(ws.AccelState.Values.X) > Math.Abs(this.accelX) + kFilteringFactor ||
                    Math.Abs(ws.AccelState.Values.Y) > Math.Abs(this.accelY) + kFilteringFactor ||
                    Math.Abs(ws.AccelState.Values.Z) > Math.Abs(this.accelZ) + kFilteringFactor)
                    startRecording = true;
            }

            if (startRecording == true)
            {
                if (ws.MotionPlusState.PitchFast)//moltiplicato 0.01 perchè campiono a 100Hz, per ottenere lo spostamento reale
                    angleY = ((ws.MotionPlusState.RawValues.X - this.calibrationValueX) / 5) * 0.01;
                else if (!ws.MotionPlusState.PitchFast)
                    angleY = ((ws.MotionPlusState.RawValues.X - this.calibrationValueX) / 20) * 0.01;

                if (ws.MotionPlusState.RollFast)
                    angleZ = ((ws.MotionPlusState.RawValues.Y - this.calibrationValueY) / 5) * 0.01;
                else if (!ws.MotionPlusState.RollFast)
                    angleZ = ((ws.MotionPlusState.RawValues.Y - this.calibrationValueY) / 20) * 0.01;

                if (ws.MotionPlusState.YawFast)
                    angleX = ((ws.MotionPlusState.RawValues.Z - this.calibrationValueZ) / 5) * 0.01;
                else if (!ws.MotionPlusState.YawFast)
                    angleX = ((ws.MotionPlusState.RawValues.Z - this.calibrationValueZ) / 20) * 0.01;

              /*  if (ws.MotionPlusState.PitchFast)//moltiplicato 0.01 perchè campiono a 100Hz, per ottenere lo spostamento reale
                    angleY += ((ws.MotionPlusState.RawValues.X - this.calibrationValueX) / 5) * 0.01;
                else if (!ws.MotionPlusState.PitchFast)
                    angleY += ((ws.MotionPlusState.RawValues.X - this.calibrationValueX) / 20) * 0.01;

                if (ws.MotionPlusState.RollFast)
                    angleZ += ((ws.MotionPlusState.RawValues.Y - this.calibrationValueY) / 5) * 0.01;
                else if (!ws.MotionPlusState.RollFast)
                    angleZ += ((ws.MotionPlusState.RawValues.Y - this.calibrationValueY) / 20) * 0.01;

                if (ws.MotionPlusState.YawFast)
                    angleX += ((ws.MotionPlusState.RawValues.Z - this.calibrationValueZ) / 5) * 0.01;
                else if (!ws.MotionPlusState.YawFast)
                    angleX += ((ws.MotionPlusState.RawValues.Z - this.calibrationValueZ) / 20) * 0.01;
              
                */

             /*   if (roboM.training)
                    this.roboM.WriteCoordsInModel(ws.AccelState.Values.X, ws.AccelState.Values.Y, ws.AccelState.Values.Z, ws.MotionPlusState.RollFast, ws.MotionPlusState.PitchFast, ws.MotionPlusState.YawFast);
                else
                    this.roboM.WriteCoordsInRecognitionModel(ws.AccelState.Values.X, ws.AccelState.Values.Y, ws.AccelState.Values.Z, ws.MotionPlusState.RollFast, ws.MotionPlusState.PitchFast, ws.MotionPlusState.YawFast);
                */
                if (roboM.training)
                    this.roboM.WriteCoordsInModel(ws.AccelState.Values.X, ws.AccelState.Values.Y, ws.AccelState.Values.Z, ws.MotionPlusState.RollFast, ws.MotionPlusState.PitchFast, ws.MotionPlusState.YawFast, angleX, angleY, angleZ);
                else
                    this.roboM.WriteCoordsInRecognitionModel(ws.AccelState.Values.X, ws.AccelState.Values.Y, ws.AccelState.Values.Z, ws.MotionPlusState.RollFast, ws.MotionPlusState.PitchFast, ws.MotionPlusState.YawFast, angleX, angleY, angleZ);
               

              //  double plusX = ws.MotionPlusState.Values.X;
            }
           // pointIndex += 1;
           

            //button don't care
            //only accelleration value interest 
            /*if (ws.ButtonState.B)
            {
                str = "button B\n";
                roboM.externwriteOnLog(str);
          
            }
            if (ws.ButtonState.Plus)
            {
                str = "button Plus\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.ButtonState.Home)
            {
                str = "button Home\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.ButtonState.Minus)
            {
                str = "button Minus\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.ButtonState.Up)
            {
                str = "button Up\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.ButtonState.Down)
            {
                str = "button Down\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.ButtonState.Left)
            {
                str = "button Left\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.ButtonState.Right)
            {
                str = "button Right\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.ButtonState.One)
            {
                str = "button One\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.ButtonState.Two)
            {
                str = "button Two\n";
                roboM.externwriteOnLog(str);
            }
          
            if ( ws.AccelState.Values.Z < -1.5)
            {
                roboM.
                roboM.externwriteOnLog(str);
            }
            if (ws.AccelState.Values.Z > 1.5)
            {
                str = "y = Down\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.AccelState.Values.X > 0.6)
            {
                str = "x = 1\n";
                roboM.externwriteOnLog(str);
            }
            if (ws.AccelState.Values.X < -0.6)
            {
                str = "x = -1\n";
                roboM.externwriteOnLog(str);
            }
            */
        }
    }
}
